--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local InkedCastBarColors = {r = playerColor.r*0.99, g = playerColor.g*0.99,b = playerColor.b*0.99,a = 1}
local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...
local InCombatLockdown      = _G.InCombatLockdown;
local InkedBackDropNFO =
	{
		bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Buttons\\WHITE8x8",
		tile = true,
		tileEdge = true,
		tileSize = 8,
		edgeSize = 1,
		insets = { left = 0, right = 0, top = 0, bottom =0 },
		
	}

local InkedWrapNFO =
	{
		bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-border",
		tile = true,
		tileEdge = true,
		tileSize = 1,
		edgeSize = 24,
		insets = { left = 4, right = 4, top = 4, bottom = 4 },
		
	}

local function HealthWrap(frame)
	local HealthWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		HealthWrapper:SetPoint("LEFT",frame,"LEFT",-5,0)
		HealthWrapper:SetSize(148,39)
		HealthWrapper:SetBackdrop(InkedWrapNFO) 
		HealthWrapper:SetBackdropColor(1,0,0,0)
		HealthWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
		if Inked.db.profile.PlayerClassColor == true then
			HealthWrapper:SetBackdropBorderColor(InkedColors.r, InkedColors.g, InkedColors.b, InkedColors.a)
		elseif Inked.db.profile.PlayerClassColor == false then
			if Inked.db.profile.PlayerCustomColor == true then
				HealthWrapper:SetBackdropBorderColor(Inked.db.profile.PlayerColorR,Inked.db.profile.PlayerColorG,Inked.db.profile.PlayerColorB,Inked.db.profile.PlayerColorA)
			elseif Inked.db.profile.PlayerCustomColor == false then
				HealthWrapper:SetBackdropBorderColor(1,1,1,1)
			end
		end
end
local function PowerWrap(frame)
	local PowerWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PowerWrapper:SetPoint("LEFT",frame,"LEFT",-5,0)
		PowerWrapper:SetSize(148,32)
		PowerWrapper:SetBackdrop(InkedWrapNFO) 
		PowerWrapper:SetBackdropColor(0,0,0,0)
		PowerWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
		if Inked.db.profile.PlayerClassColor == true then
			PowerWrapper:SetBackdropBorderColor(InkedColors.r, InkedColors.g, InkedColors.b, InkedColors.a)
		elseif Inked.db.profile.PlayerClassColor == false then
			if Inked.db.profile.PlayerCustomColor == true then
				PowerWrapper:SetBackdropBorderColor(Inked.db.profile.PlayerColorR,Inked.db.profile.PlayerColorG,Inked.db.profile.PlayerColorB,Inked.db.profile.PlayerColorA)
			elseif Inked.db.profile.PlayerCustomColor == false then
				PowerWrapper:SetBackdropBorderColor(1,1,1,1)
			end
		end
end
local function CastBarWrap(frame)
	local CastBarWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		CastBarWrapper:SetPoint("LEFT",frame,"LEFT",-2,0)
		CastBarWrapper:SetSize(185,30)
		CastBarWrapper:SetBackdrop(InkedWrapNFO) 
		CastBarWrapper:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
		CastBarWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
		if Inked.db.profile.PlayerClassColor == true then
			CastBarWrapper:SetBackdropBorderColor(InkedColors.r, InkedColors.g, InkedColors.b, InkedColors.a)
		elseif Inked.db.profile.PlayerClassColor == false then
			if Inked.db.profile.PlayerCustomColor == true then
				CastBarWrapper:SetBackdropBorderColor(Inked.db.profile.PlayerColorR,Inked.db.profile.PlayerColorG,Inked.db.profile.PlayerColorB,Inked.db.profile.PlayerColorA)
			elseif Inked.db.profile.PlayerCustomColor == false then
				CastBarWrapper:SetBackdropBorderColor(1,1,1,1)
			end
		end
end
local function AltPowerWrap(frame)
	local AltPowerWrap = CreateFrame("Frame","AltPowerWrap",frame, BackdropTemplateMixin and "BackdropTemplate")
		AltPowerWrap:SetPoint("LEFT",frame,"LEFT",-2,0)
		AltPowerWrap:SetSize(142,30)
		AltPowerWrap:SetBackdrop(InkedWrapNFO) 
		AltPowerWrap:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
		AltPowerWrap:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
		if Inked.db.profile.PlayerClassColor == true then
			AltPowerWrap:SetBackdropBorderColor(InkedColors.r, InkedColors.g, InkedColors.b, InkedColors.a)
		elseif Inked.db.profile.PlayerClassColor == false then
			if Inked.db.profile.PlayerCustomColor == true then
				AltPowerWrap:SetBackdropBorderColor(Inked.db.profile.PlayerColorR,Inked.db.profile.PlayerColorG,Inked.db.profile.PlayerColorB,Inked.db.profile.PlayerColorA)
			elseif Inked.db.profile.PlayerCustomColor == false then
				AltPowerWrap:SetBackdropBorderColor(1,1,1,1)
			end
		end
end
local function CastBarBackdrop(frame)

      frame:SetBackdrop(InkedBackDropNFO) 
		frame:SetBackdropColor(0,0,0,1)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function HealthBackdrop(frame)
--frame:SetSize(190,30)
      frame:SetBackdrop(InkedBackDropNFO) 
		frame:SetBackdropColor(0.7,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function PowerBackdrop(frame)
      frame:SetBackdrop(InkedBackDropNFO) 
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function RuneBackdrop(frame)
		frame:SetBackdrop(InkedBackDropNFO) 
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(1,1,1,0)
end
local function PortraitWrap(frame)
	local PortraitWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PortraitWrapper:SetFrameLevel(1)
		PortraitWrapper:SetPoint("LEFT",frame,"LEFT",-5,0)
		PortraitWrapper:SetSize(70,72)
		PortraitWrapper:SetBackdrop(InkedWrapNFO) 
		PortraitWrapper:SetBackdropColor(0,0,0,1)
		PortraitWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
		if Inked.db.profile.PlayerClassColor == true then
			PortraitWrapper:SetBackdropBorderColor(InkedColors.r, InkedColors.g, InkedColors.b, InkedColors.a)
		elseif Inked.db.profile.PlayerClassColor == false then
			if Inked.db.profile.PlayerCustomColor == true then
				PortraitWrapper:SetBackdropBorderColor(Inked.db.profile.PlayerColorR,Inked.db.profile.PlayerColorG,Inked.db.profile.PlayerColorB,Inked.db.profile.PlayerColorA)
			elseif Inked.db.profile.PlayerCustomColor == false then
				PortraitWrapper:SetBackdropBorderColor(1,1,1,1)
			end
		end
end
local function CreateBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end

local Mover = CreateFrame("Frame","PlayerDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	Mover:SetSize(132,55)
	Mover:SetPoint("CENTER",UIParent,"CENTER",-235,-250)
	
	Mover:SetClampedToScreen(true)
	Mover:SetClampRectInsets(0, 0, 0,0)
	
local MoverText  = Mover:CreateFontString(nil, "OVERLAY")
	MoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	MoverText:SetPoint("CENTER",Mover,"CENTER", 0,0); 
	MoverText:SetText("")

local function UpdateMe()
		if(Inked.db.profile.lockframes == false) then
			Inked.db.profile.PlayerX = 0
			Inked.db.profile.PlayerY = 0
			local point, relativeTo, relativePoint, xOfs, yOfs = Mover:GetPoint(n)
			Inked.db.profile.PlayerX = xOfs
			Inked.db.profile.PlayerY = yOfs
			Inked.db.profile.PlayerPoint = point
			Mover:SetMovable(true)
			Mover:EnableMouse(true)
			Mover:RegisterForDrag("LeftButton")
			Mover:SetScript("OnDragStart", Mover.StartMoving)
			Mover:SetScript("OnDragStop", Mover.StopMovingOrSizing)
			Mover:SetUserPlaced(true)
			MoverText:SetText("Player Frame")
			Mover:SetBackdrop(InkedBackDropNFO) 
			Mover:SetBackdropColor(0,0.55,0.95,0.45)
			Mover:SetBackdropBorderColor(0,0.55,0.95,0)
			
		end	
end	
	---Update Database check
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)

local UnitSpecific = {
	player = function(self)	
	if Inked.db.profile.PlayerFrameEnable == false then return end
	local InkedUnitFrame = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	InkedUnitFrame:SetHeight(100)
	InkedUnitFrame:SetWidth(205)
	InkedUnitFrame:ClearAllPoints()
	InkedUnitFrame:SetPoint("RIGHT", self,5,10)
	InkedUnitFrame:SetScale(1)
	InkedUnitFrame:SetFrameStrata("HIGH")
		
		--------------------
		--  Player Set Up --
		--------------------
		local PlayerWidth = 132;
		local PlayerHeight = 55;
		local PortraitWidth = 55;
		local PortraitHeight = 58;
		self:SetSize(PlayerWidth,PlayerHeight)
		----------------------
		--  Health and Power--
		----------------------
		self.Health:SetHeight(33)
		self.Power:SetHeight(28)
		----------------------
		--  Player Portrait --
		----------------------
		if Inked.db.profile.PlayerPortrait == true then
			self.Portrait:SetPoint('RIGHT', self, 'LEFT',-16,-5)
			self.Portrait:SetSize(PortraitWidth, PortraitHeight)	
		end
		----------------------
		--  Player Level --
		----------------------	
		local LevelText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText")	
		if Inked.db.profile.PlayerPortrait == true then
			LevelText:SetPoint('BOTTOM', self, 'TOP',-115,8)
		elseif Inked.db.profile.PlayerPortrait == false then
			LevelText:SetPoint('BOTTOM', self, 'TOP',-60,8)
		end
		LevelText:SetFont(LSM:Fetch("font", Inked.db.profile.PlayerLevelfont), Inked.db.profile.PlayerLevelFontSize, Inked.db.profile.PlayerLevelOutline)
		LevelText:SetJustifyH("LEFT")
		if Inked.db.profile.PlayerShowLevel == true then
		self:Tag(LevelText, "[level]")	
		end
		------------------
		--  Player Name --
		------------------		
		local NameText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText")	
		if Inked.db.profile.PlayerPortrait == true then
			NameText:SetPoint('BOTTOM', self, 'TOP',37,8) 
		elseif Inked.db.profile.PlayerPortrait == false then
			NameText:SetPoint('BOTTOM', self, 'TOP',67,8) 
		end
		NameText:SetFont(LSM:Fetch("font", Inked.db.profile.PlayerNamefont), Inked.db.profile.PlayerNameFontSize, Inked.db.profile.PlayerNameOutline)
		NameText:SetJustifyH("LEFT")
		NameText:SetWidth(200)	
		if Inked.db.profile.PlayerShowName == true then
		self:Tag(NameText, "[name]")
		end
		---------------------------
		--  Player Health Values --
		---------------------------		
		local HealthText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 	
		if Inked.db.profile.PlayerShowHealthPercent == true then
			HealthText:SetPoint("CENTER", self, 0,10)
		elseif Inked.db.profile.PlayerShowBothNumberandPercent == true then
			HealthText:SetPoint("RIGHT", self, -2,10) 
		end			
		HealthText:SetFont(LSM:Fetch("font", Inked.db.profile.PlayerHealthfont), Inked.db.profile.PlayerHealthFontSize, Inked.db.profile.PlayerHealthOutline)
		HealthText:SetJustifyH("RIGHT")
		if Inked.db.profile.PlayerShowHealthPercent == true  or Inked.db.profile.PlayerShowBothNumberandPercent then
		self:Tag(HealthText, "[perhp]".." %") 	
		end
		local HealthText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if Inked.db.profile.PlayerShowHealthNumbers == true then
			HealthText2:SetPoint("CENTER", self, 0,10)
		elseif Inked.db.profile.PlayerShowBothNumberandPercent == true then
			HealthText2:SetPoint("LEFT", self, 2,10)
		end
		HealthText2:SetFont(LSM:Fetch("font", Inked.db.profile.PlayerHealthfont), Inked.db.profile.PlayerHealthFontSize, Inked.db.profile.PlayerHealthOutline)
		HealthText2:SetJustifyH("LEFT")	
		if Inked.db.profile.PlayerShowHealthNumbers == true  or Inked.db.profile.PlayerShowBothNumberandPercent then
			self:Tag(HealthText2, "[Inked:MyHealth]")
		end
		--------------------------
		--  Player Power Values --
		--------------------------		

		local PowerText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		
		if Inked.db.profile.PlayerShowPowerPercent == true then
			PowerText:SetPoint("CENTER", self, 0,-24)
		elseif Inked.db.profile.PlayerShowBothPowerNumberandPercent == true then
			PowerText:SetPoint("RIGHT", self, -2, -24) 	
		end			
		PowerText:SetFont(LSM:Fetch("font", Inked.db.profile.PlayerPowerfont), Inked.db.profile.PlayerPowerFontSize, Inked.db.profile.PlayerPowerOutline)
		PowerText:SetJustifyH("RIGHT")	
		if Inked.db.profile.PlayerShowPowerPercent == true  or Inked.db.profile.PlayerShowBothPowerNumberandPercent then
			self:Tag(PowerText, "[perpp]".." %")
		end	
		local PowerText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if Inked.db.profile.PlayerShowPowerNumbers == true then
			PowerText2:SetPoint("CENTER", self, 0,-24)
		elseif Inked.db.profile.PlayerShowBothPowerNumberandPercent == true then
			PowerText2:SetPoint("LEFT", self, 2, -24) 
		end								
		PowerText2:SetFont(LSM:Fetch("font", Inked.db.profile.PlayerPowerfont), Inked.db.profile.PlayerPowerFontSize, Inked.db.profile.PlayerPowerOutline)
		PowerText2:SetJustifyH("LEFT")	
		if Inked.db.profile.PlayerShowPowerNumbers == true  or Inked.db.profile.PlayerShowBothPowerNumberandPercent then
			self:Tag(PowerText2, "[Inked:MyPower]")
		end
		local PowerText3 = self.Power:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText3:SetPoint("CENTER", self, 0,-24) -- but anchor to the base element so it doesn't wiggle
		PowerText3:SetFont(LSM:Fetch("font", Inked.db.profile.PlayerPowerfont), Inked.db.profile.PlayerPowerFontSize, Inked.db.profile.PlayerPowerOutline)
		PowerText3:SetJustifyH("CENTER")
		self:Tag(PowerText3, "[curpp]") -- oUF will automagically update it!
		PowerText3:SetAlpha(0)
				
		local function InkedPowerFunction()
					if(select(2, UnitClass('player')) == 'WARRIOR') or (select(2, UnitClass('player')) == 'ROGUE') or (select(2, UnitClass('player')) == 'DRUID') or (select(2, UnitClass('player')) == 'DEATHKNIGHT') or (select(2, UnitClass('player')) == 'DEMONHUNTER')then
						if(select(2, UnitClass('player')) == 'DRUID') then
							local form = GetShapeshiftFormID()
							if (form == BEAR_FORM or form == CAT_FORM) then
								PowerText3:SetAlpha(1)
								self:Tag(PowerText3, "[curpp]")
								PowerText2:SetAlpha(0)
								PowerText:SetAlpha(0)
						
							end
						elseif(select(2, UnitClass('player')) == 'WARRIOR') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0)
							PowerText:SetAlpha(0)
						elseif(select(2, UnitClass('player')) == 'ROGUE') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0)
							PowerText:SetAlpha(0)
						elseif(select(2, UnitClass('player')) == 'DEATHKNIGHT') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0)
							PowerText:SetAlpha(0)
						elseif(select(2, UnitClass('player')) == 'DEMONHUNTER') then
							PowerText3:SetAlpha(1)
							PowerText2:SetAlpha(0)
							PowerText:SetAlpha(0)

						end
					else
						PowerText3:SetAlpha(0)
						PowerText2:SetAlpha(1)
						PowerText:SetAlpha(1)
					end
					if(select(2, UnitClass('player')) == 'DRUID') then
						local spec = GetSpecialization()
							if spec == 1 then
								PowerText3:SetAlpha(1)
								PowerText2:SetAlpha(0)
								PowerText:SetAlpha(0)
							end
					end
					if(select(2, UnitClass('player')) == 'PRIEST') then
						local spec = GetSpecialization()
							if spec == 3 then
								PowerText3:SetAlpha(1)
								PowerText2:SetAlpha(0)
								PowerText:SetAlpha(0)
								
							end
					end
					if(select(2, UnitClass('player')) == 'MONK') then
						local spec = GetSpecialization()
							if spec == 1 or spec == 3 then
								PowerText3:SetAlpha(1)
								PowerText2:SetAlpha(0)
								PowerText:SetAlpha(0)
								
							end
					end
					if(select(2, UnitClass('player')) == 'SHAMAN') then
						local spec = GetSpecialization()
							if spec ~= 3 then
								PowerText3:SetAlpha(1)
								PowerText2:SetAlpha(0)
								PowerText:SetAlpha(0)
							end
							
					end
				end
		local InkedPowerEvent = CreateFrame("FRAME")
		InkedPowerEvent:HookScript("OnUpdate", InkedPowerFunction)
		
		----------------------
		--  Player Cast Bar --
		----------------------
		if Inked.db.profile.PlayerCastBar == true then
			self.Castbar:SetSize(180, 20)
			self.Castbar:SetPoint('BOTTOMRIGHT', self.Health, 0, -80)
		end

		------------------
		--  Player Aura --
		------------------
		if Inked.db.profile.PlayerAuras == true then
			local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
			if Inked.db.profile.PlayerPortrait == true then
				Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", -68,40)
			elseif Inked.db.profile.PlayerPortrait == false then
				Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", -5,40)
			end
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 40)
			Auras:SetHeight(30 + 4)
			Auras.disableMouse = false

			Auras.size = 30
			Auras.onlyShowPlayer = false
			Auras.gap = 2
			Auras.spacing = 2
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 32

			Auras.PostCreateIcon = Aura_PostCreateIcon
			self.Auras = Auras
		end
		
				
		-------------------------
		--  Player Combat Icon --
		-------------------------

		local CombatIndicator = self:CreateTexture(nil, 'OVERLAY')
		CombatIndicator:SetSize(40, 40)
		CombatIndicator:SetPoint("LEFT",self,"RIGHT",0,-10)

		self.CombatIndicator = CombatIndicator
		-----------------------
		--  Player Rest Icon --
		-----------------------
		
		local RestingIndicator = self:CreateTexture(nil, 'OVERLAY')
		RestingIndicator:SetSize(40, 40)
		if Inked.db.profile.PlayerPortrait == true then
			RestingIndicator:SetPoint("CENTER",self,"CENTER",-143,45)
		elseif Inked.db.profile.PlayerPortrait == false then
			RestingIndicator:SetPoint("CENTER",self,"CENTER",-90,5)
		end
		self.RestingIndicator = RestingIndicator
	
		----------------------
		--  Player PVP Text --
		----------------------
		
		local PVPText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PVPText:SetPoint("CENTER", self, -5,-47) -- but anchor to the base element so it doesn't wiggle
		PVPText:SetFont(LSM:Fetch("font", Inked.db.profile.PlayerPVPfont), Inked.db.profile.PlayerPVPFontSize, Inked.db.profile.PlayerPVPOutline)

		local function pvpTimerFormat(left)
			mins = math.floor(left / 60)
			secs = math.floor(left - (mins * 60))
			return string.format("%d:%02d", mins, secs)
		end
		
		function PlayerPVPMe()
			if UnitIsPVP("player") then
					local time = GetPVPTimer()
					if time < 301000 then
						PVPText:SetText("PVP: "..pvpTimerFormat(time / 1000))
					end
			else
				PVPText:SetText("")
			end
		end
		local PlayerPVPMeframe = CreateFrame("Frame")
		PlayerPVPMeframe:HookScript("OnUpdate", PlayerPVPMe)
	oUF:RegisterInitCallback(addPvPTimer)
	
	local PvPIndicator = self:CreateTexture(nil, 'ARTWORK', nil, 1)
    PvPIndicator:SetSize(30, 30)
    PvPIndicator:SetPoint('LEFT', self, 'RIGHT',0,-5)

    local Badge = self:CreateTexture(nil, 'ARTWORK')
    Badge:SetSize(50, 52)
    Badge:SetPoint('CENTER', PvPIndicator, 'CENTER')

    PvPIndicator.Badge = Badge
    self.PvPIndicator = PvPIndicator
	
		---------------------------------
		--  Player Class Power  --
		---------------------------------

			local ClassPower = {}
			for index = 1, 10 do
			local Bar = CreateFrame('StatusBar', nil, self, BackdropTemplateMixin and "BackdropTemplate")
			Bar:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.PlayerPowerStatusBar))

			Bar:SetSize(25, 18)
			Bar:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', ((index -1) * (Bar:GetWidth()+3))-5, -88)
				
			ClassPower[index] = Bar
			end

		self.ClassPower = ClassPower
		
		---------------------------------
		--  Death Knight Runess        --
		---------------------------------

	if(select(2, UnitClass('player')) == 'DEATHKNIGHT') then

		local Runes = {}
		local spec = GetSpecialization()
		for index = 1, 6 do
			local Rune = CreateFrame('StatusBar', nil, self, BackdropTemplateMixin and "BackdropTemplate")
			Rune:SetSize(90/ 6, 22)
			Rune:SetOrientation("VERTICAL")
			Rune:SetStatusBarTexture("Interface\\Buttons\\WHITE8x8")
			Rune:SetStatusBarColor(.6,.2,.8,1)
			Rune:SetBackdrop(InkedBackDropNFO) 
				Rune:SetBackdropColor(0,0.55,0.95,0.45)
				Rune:SetBackdropBorderColor(0,0.55,0.95,0)

			
			--print(spec)
			if spec == 1 then
			Rune:SetStatusBarColor(1,0,0,1)
			Rune:SetStatusBarTexture("Interface\\Addons\\Inked\\Graphics\\Statusbars\\DKRunes_Red")
			
			end
			if spec == 2 then
			Rune:SetStatusBarColor(0,0.55,0.95,0.45)
			Rune:SetStatusBarTexture("Interface\\Addons\\Inked\\Graphics\\Statusbars\\DKRunes_Blue")

			end
			if spec == 3 then
			
			
			
			Rune:SetStatusBarColor(0,0,1,1)
			Rune:SetStatusBarTexture("Interface\\Addons\\Inked\\Graphics\\Statusbars\\DKRunes_Green")

			end
			
			Rune:SetReverseFill(true);
			RuneBackdrop(Rune)
			
			Rune:SetPoint('TOPLEFT', self, 'BOTTOMLEFT', ((index * 120 / 6)* 1.15)-26, -14)
			Runes[index] = Rune
		end

		self.Runes = Runes
	 end
	 
	--------------
	-- Rez Icon --
	--------------
	local ResurrectIndicator = self:CreateTexture(nil, 'OVERLAY')
    ResurrectIndicator:SetSize(24, 24)
    ResurrectIndicator:SetPoint('RIGHT', self,25,42)
	self.ResurrectIndicator = ResurrectIndicator
	
	--------------------------
	-- Group Role Indicator --
	--------------------------

    local GroupRoleIndicator = self:CreateTexture(nil, 'OVERLAY')
    GroupRoleIndicator:SetSize(24, 24)
    GroupRoleIndicator:SetPoint('RIGHT', self,25,18)
	GroupRoleIndicator:Show()
    self.GroupRoleIndicator = GroupRoleIndicator
	
	 local RaidRoleIndicator = self:CreateTexture(nil, 'OVERLAY')
    RaidRoleIndicator:SetSize(24, 24)
    RaidRoleIndicator:SetPoint('RIGHT', self,25,18)
    -- Register it with oUF
    self.RaidRoleIndicator = RaidRoleIndicator
	
	local SummonIndicator = self:CreateTexture(nil, 'OVERLAY')
    SummonIndicator:SetSize(32, 32)
    SummonIndicator:SetPoint('RIGHT', self,25,-30)

    -- Register it with oUF
    self.SummonIndicator = SummonIndicator

	----------------
	-- Raid icons --
	----------------

	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(24, 24)
	RaidTargetIndicator:SetPoint('RIGHT', self,25,-6)
	self.RaidTargetIndicator = RaidTargetIndicator
	
	---------------------------------
	--  Player Floating Combat Text--
	---------------------------------
	if Inked.db.profile.PlayerFCF == true then
		local fcf = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		fcf:SetSize(24, 24)
		fcf:SetPoint("CENTER",0,150)
		for i = 1, 6 do
			-- give names to these font strings to avoid breaking /fstack and /tinspect
			fcf[i] = fcf:CreateFontString("$parentFCFText" .. i, "OVERLAY")
		end
		
		fcf.font = LSM:Fetch("font", Inked.db.profile.PlayerFloatingCombatTextfont)
		fcf.fontHeight = Inked.db.profile.PlayerFloatingCombatTextFontSize
		fcf.fontFlags = Inked.db.profile.PlayerFloatingCombatTextOutline
		self.FloatingCombatFeedback = fcf
	end
	
	---------------------------------
	--  Health Prediction--
	---------------------------------
	if Inked.db.profile.PlayerHealthPrediction == true then
		local myBar = CreateFrame('StatusBar', nil, self.Health)
		myBar:SetPoint('TOP')
		myBar:SetPoint('BOTTOM')
		myBar:SetPoint('LEFT', self.Health:GetStatusBarTexture(), 'RIGHT')
		myBar:SetWidth(200)
		myBar:SetAlpha(0.35)

		local otherBar = CreateFrame('StatusBar', nil, self.Health)
		otherBar:SetPoint('TOP')
		otherBar:SetPoint('BOTTOM')
		otherBar:SetPoint('LEFT', self.Health:GetStatusBarTexture(), 'RIGHT')
		otherBar:SetWidth(200)
		otherBar:SetAlpha(0.35)

		local absorbBar = CreateFrame('StatusBar', nil, self.Health)
		absorbBar:SetPoint('TOP')
		absorbBar:SetPoint('BOTTOM')
		absorbBar:SetPoint('LEFT', self.Health:GetStatusBarTexture(), 'RIGHT')
		absorbBar:SetWidth(200)
		absorbBar:SetAlpha(0.35)

		local healAbsorbBar = CreateFrame('StatusBar', nil, self.Health)
		healAbsorbBar:SetPoint('TOP')
		healAbsorbBar:SetPoint('BOTTOM')
		healAbsorbBar:SetPoint('RIGHT', self.Health:GetStatusBarTexture())
		healAbsorbBar:SetWidth(200)
		healAbsorbBar:SetReverseFill(true)
		healAbsorbBar:SetAlpha(0.35)

		local overAbsorb = self.Health:CreateTexture(nil, "OVERLAY")
		overAbsorb:SetPoint('TOP')
		overAbsorb:SetPoint('BOTTOM')
		overAbsorb:SetPoint('LEFT', self.Health, 'RIGHT')
		overAbsorb:SetWidth(10)
		overAbsorb:SetAlpha(0.35)

		local overHealAbsorb = self.Health:CreateTexture(nil, "OVERLAY")
		overHealAbsorb:SetPoint('TOP')
		overHealAbsorb:SetPoint('BOTTOM')
		overHealAbsorb:SetPoint('RIGHT', self.Health, 'LEFT')
		overHealAbsorb:SetWidth(10)
		overHealAbsorb:SetAlpha(0.35)


		self.HealthPrediction = {
			myBar = myBar,
			otherBar = otherBar,
			absorbBar = absorbBar,
			healAbsorbBar = healAbsorbBar,
			overAbsorb = overAbsorb,
			overHealAbsorb = overHealAbsorb,
			maxOverflow = 0.99,
		}
	end
	end,-- End Player
}
	
	local Shared = function(self, unit)	
	if Inked.db.profile.PlayerFrameEnable == false then return end
	self:SetScale(Inked.db.profile.PlayerScale)

	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------
	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.PlayerHealthStatusBar))
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT',-5,0)
	Health:SetPoint('RIGHT')
	Health:SetFrameLevel(2)
	HealthWrap(Health)
	HealthBackdrop(Health)
	

	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	if Inked.db.profile.PlayerHealthStatusBarClassClored == true then
		Health.colorClass = true
	end
	Health.colorReaction = true
	Health.colorHealth = true
	self.Health = Health
	self.Health.bg = Healthbg
	
	

    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.PlayerPowerStatusBar))
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-32)
	 Power:SetPoint('LEFT',0,0)
	-- Power:SetPoint('RIGHT')
	Power:SetFrameLevel(1)
	PowerWrap(Power)
	PowerBackdrop(Power)
	Power.frequentUpdates = true
	Power.colorPower = true 
	Power.colorClassNPC = false
	Power.colorClassPet = false 
	self.Power = Power	

	------------------
	--   Portrait --
	------------------
	-- 3D Portrait	
	if Inked.db.profile.PlayerPortrait == true then
		local Portrait = CreateFrame('PlayerModel', nil, self, BackdropTemplateMixin and "BackdropTemplate")	
		PortraitWrap(Portrait)
		-- 2D Square
		--local Portrait = self:CreateTexture(nil, 'OVERLAY')
		--Portrait:SetTexCoord(0.15,0.88,0.15,0.85)		
		self.Portrait = Portrait	
	end
	


	--------------
	-- Cast Bar --
	--------------
	if Inked.db.profile.PlayerCastBar == true then
		local Castbar = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		Castbar:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.PlayerCastBarStatusBar))
		Castbar:SetStatusBarColor(InkedCastBarColors.r,InkedCastBarColors.g,InkedCastBarColors.b,1)
		-- Add a background
		CastBarBackdrop(Castbar)
		CastBarWrap(Castbar)
		-- Add a spark
		local Spark = Castbar:CreateTexture(nil, "OVERLAY")
		Spark:SetSize(40, 35)
		Spark:SetBlendMode("ADD")
		Spark:SetPoint('CENTER', Castbar:GetStatusBarTexture(), 'RIGHT', 0, 0)
		-- Add a timer
		local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Time:SetFont(LSM:Fetch("font", Inked.db.profile.PlayerCastBarfont), Inked.db.profile.PlayerCastBarFontSize, Inked.db.profile.PlayerCastBarOutline)
		Time:SetTextColor(0.95, 0.95, 0.95)
		Time:SetPoint("RIGHT", Castbar, -3, 0)
		-- Add spell text
		local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Text:SetFont(LSM:Fetch("font", Inked.db.profile.PlayerCastBarfont), Inked.db.profile.PlayerCastBarFontSize, Inked.db.profile.PlayerCastBarOutline)
		Text:SetTextColor(0.95, 0.95, 0.95)
		Text:SetPoint("LEFT", Castbar, 3, 0)
		-- Add Shield
		local Shield = Castbar:CreateTexture(nil, "OVERLAY")
		Shield:SetSize(22, 15)
		Shield:SetPoint("CENTER", Castbar)
		-- Add Icon
		local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
		Icon:SetSize(22, 22)
		Icon:SetPoint('LEFT', Castbar, 'LEFT',-24,0)
		-- Add safezone
		local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")
		self.Castbar = Castbar
		self.Castbar.bg = Background
		self.Castbar.Spark = Spark
		self.Castbar.Time = Time
		self.Castbar.Text = Text
		self.Castbar.SafeZone = SafeZone
		self.Castbar.Icon = Icon
	end
	-----------------
	-- Smooth Bars --
	-----------------
	self.Health.Smooth = true
	if self.Power then
		self.Power.Smooth = true
	end
		
	local AdditionalPower = CreateFrame('StatusBar', nil, self, BackdropTemplateMixin and "BackdropTemplate")
	AdditionalPower:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.PlayerPowerStatusBar))
	AdditionalPower.colorPower = true
	AdditionalPower:SetFrameLevel(1)
	AdditionalPower:SetSize(34, 20)
	AdditionalPower:SetPoint('BOTTOM',-14,-32)
	AdditionalPower:SetPoint('LEFT',-4,0)
	AdditionalPower:SetPoint('RIGHT',1,0)
	PowerBackdrop(AdditionalPower)
	AltPowerWrap(AdditionalPower)
				
	self.AdditionalPower = AdditionalPower
	local MyMana = UnitPower(unit, Enum.PowerType.Mana)
	local ManaText = AdditionalPower:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
	ManaText:SetPoint("CENTER", AdditionalPower, 0,1) -- but anchor to the base element so it doesn't wiggle
	ManaText:SetFont(LSM:Fetch("font", Inked.db.profile.PlayerPowerfont), Inked.db.profile.PlayerPowerFontSize, Inked.db.profile.PlayerPowerOutline)
	ManaText:SetJustifyH("LEFT")
	self:Tag(ManaText,"[curmana]".." K")
	
		
	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("InkedPlayer", Shared)
oUF:Factory(function(self)
if Inked.db.profile.PlayerFrameEnable == false then return end

		PlayerX = Inked.db.profile.PlayerX
		PlayerY = Inked.db.profile.PlayerY
	-----------------
	-- Unit Set Up --
	-----------------
     self:SetActiveStyle("InkedPlayer")
	 if Inked.db.profile.PlayerPoint == nil then
		self:Spawn("player"):SetPoint("Center",UIParent,PlayerX,PlayerY)
		Mover:SetPoint("Center",UIParent,Inked.db.profile.PlayerX,Inked.db.profile.PlayerY)
	 else
		self:Spawn("player"):SetPoint(Inked.db.profile.PlayerPoint,UIParent,PlayerX,PlayerY)
		Mover:SetPoint(Inked.db.profile.PlayerPoint,UIParent,Inked.db.profile.PlayerX,Inked.db.profile.PlayerY)
	 end

end)
