--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
--local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('target'))]
local rPerc, gPerc, bPerc, argbHex = GetClassColor(englishClass)
local InkedColors = {r = rPerc*0.75, g = gPerc*0.75,b = bPerc*0.75,a = 1}
local InkedCastBarColors = {r = rPerc*0.99, g = gPerc*0.99,b = bPerc*0.99,a = 1}
local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...
local InCombatLockdown      = _G.InCombatLockdown;
local InkedBackDropNFO =
	{
		bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Buttons\\WHITE8x8",
		tile = true,
		tileEdge = true,
		tileSize = 8,
		edgeSize = 1,
		insets = { left = 0, right = 0, top = 0, bottom =0 },
		
	}

local InkedWrapNFO =
	{
		bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-border",
		tile = true,
		tileEdge = true,
		tileSize = 1,
		edgeSize = 24,
		insets = { left = 4, right = 4, top = 4, bottom = 4 },
		
	}


local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local function HealthWrap(frame)
	local HealthWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		HealthWrapper:SetPoint("LEFT",frame,"LEFT",-4,0)
		HealthWrapper:SetSize(148,39)
		HealthWrapper:SetBackdrop(InkedWrapNFO) 
		HealthWrapper:SetBackdropColor(1,0,0,0)
end
local function PowerWrap(frame)
	local PowerWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PowerWrapper:SetPoint("LEFT",frame,"LEFT",-3,0)
		PowerWrapper:SetSize(148,32)
		PowerWrapper:SetBackdrop(InkedWrapNFO) 
		PowerWrapper:SetBackdropColor(0,0,0,0)
		PowerWrapper:SetBackdropBorderColor(1,1,1,1)
end
local function CastBarWrap(frame)
	local CastBarWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		CastBarWrapper:SetPoint("LEFT",frame,"LEFT",-2,0)
		CastBarWrapper:SetSize(187,30)
		CastBarWrapper:SetBackdrop(InkedWrapNFO) 
		CastBarWrapper:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
		CastBarWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function AltPowerWrap(frame)
	local AltPowerWrap = CreateFrame("Frame","AltPowerWrap",frame, BackdropTemplateMixin and "BackdropTemplate")
		AltPowerWrap:SetPoint("LEFT",frame,"LEFT",-2,0)
		AltPowerWrap:SetSize(128,30)
		AltPowerWrap:SetBackdrop(InkedWrapNFO) 
		AltPowerWrap:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
		AltPowerWrap:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function CastBarBackdrop(frame)
       frame:SetBackdrop(InkedBackDropNFO) 
		frame:SetBackdropColor(0,0,0,1)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function HealthBackdrop(frame)
       frame:SetBackdrop(InkedBackDropNFO) 
		frame:SetBackdropColor(0.7,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function PowerBackdrop(frame)
      frame:SetBackdrop(InkedBackDropNFO) 
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function RuneBackdrop(frame)
      frame:SetBackdrop(InkedBackDropNFO) 
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(1,1,1,0)
end
local function PortraitWrap(frame)
	local PortraitWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PortraitWrapper:SetFrameLevel(1)
		--PortraitWrapper:SetAllPoints(frame)
		PortraitWrapper:SetPoint("LEFT",frame,"LEFT",-5,0)
		PortraitWrapper:SetSize(65,68)
		PortraitWrapper:SetBackdrop(InkedWrapNFO) 
		PortraitWrapper:SetBackdropColor(0,0,0,1)
		PortraitWrapper:SetBackdropBorderColor(1,1,1,1)
end
local function CreateBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end

local MoverTarget = CreateFrame("Frame","TargetDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	MoverTarget:SetSize(132,55)
	MoverTarget:SetPoint("CENTER",UIParent,"CENTER",35,-250)
	
	MoverTarget:SetClampedToScreen(true)
	MoverTarget:SetClampRectInsets(0, 0, 0,0)
	
local MoverTargetText  = MoverTarget:CreateFontString(nil, "OVERLAY")
	MoverTargetText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	MoverTargetText:SetPoint("CENTER",MoverTarget,"CENTER", 0,0); 
	MoverTargetText:SetText("")

local function UpdateMe()
		if(Inked.db.profile.lockframes == false) then
			local point, relativeTo, relativePoint, xOfs, yOfs = MoverTarget:GetPoint(n)
			Inked.db.profile.TargetX = xOfs
			Inked.db.profile.TargetY = yOfs
			Inked.db.profile.TargetPoint = point			
			MoverTarget:SetMovable(true)
			MoverTarget:EnableMouse(true)
			MoverTarget:RegisterForDrag("LeftButton")
			MoverTarget:SetScript("OnDragStart", MoverTarget.StartMoving)
			MoverTarget:SetScript("OnDragStop", MoverTarget.StopMovingOrSizing)
			MoverTarget:SetUserPlaced(true)
			MoverTargetText:SetText("Target Frame")
			MoverTarget:SetBackdrop(InkedBackDropNFO) 
			MoverTarget:SetBackdropColor(0,0.55,0.95,0.45)
			MoverTarget:SetBackdropBorderColor(0,0.55,0.95,0)
		end	
end	
	---Update Database check
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)

local UnitSpecific = {
	target = function(self)	
		
		--------------------
		--  Target Set Up --
		--------------------
		local TargetWidth = 132;
		local TargetHeight = 55;
		local PortraitWidth = 50;
		local PortraitHeight = 58;
		self:SetSize(TargetWidth,TargetHeight)
		----------------------
		--  Health and Power--
		----------------------
		self.Health:SetHeight(33)
		self.Power:SetHeight(25)
		----------------------
		--  Target Portrait --
		----------------------
		if Inked.db.profile.TargetPortrait == true then
			self.Portrait_Target:SetPoint('LEFT', self, 'RIGHT',8,-4)
			self.Portrait_Target:SetSize(PortraitWidth, PortraitHeight)	
		end
		----------------------
		--  Target Level --
		----------------------	
		local LevelText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText")		
		LevelText:SetPoint('BOTTOM', self, 'TOP',-63,8)		
		LevelText:SetFont(LSM:Fetch("font", Inked.db.profile.TargetLevelfont), Inked.db.profile.TargetLevelFontSize, Inked.db.profile.TargetLevelOutline)
		LevelText:SetJustifyH("LEFT")
		if Inked.db.profile.TargetShowLevel == true then
		self:Tag(LevelText, "[level]")	
		end
		------------------
		--  Target Name --
		------------------		
		local NameText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText")	
		NameText:SetPoint('BOTTOM', self, 'TOP',98,8) 
		NameText:SetFont(LSM:Fetch("font", Inked.db.profile.TargetNamefont), Inked.db.profile.TargetNameFontSize, Inked.db.profile.TargetNameOutline)
		NameText:SetJustifyH("LEFT")
		NameText:SetWidth(300)	
		if Inked.db.profile.TargetShowName == true then
		self:Tag(NameText, "[name]")
		end
		---------------------------
		--  Target Health Values --
		---------------------------		
		local HealthText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 	
		if Inked.db.profile.TargetShowHealthPercent == true then
			HealthText:SetPoint("CENTER", self, 0,10)
		elseif Inked.db.profile.TargetShowBothNumberandPercent == true then
			HealthText:SetPoint("RIGHT", self, -2,10) 
		end			
		HealthText:SetFont(LSM:Fetch("font", Inked.db.profile.TargetHealthfont), Inked.db.profile.TargetHealthFontSize, Inked.db.profile.TargetHealthOutline)
		HealthText:SetJustifyH("RIGHT")
		if Inked.db.profile.TargetShowHealthPercent == true  or Inked.db.profile.TargetShowBothNumberandPercent then
		self:Tag(HealthText, "[perhp]".." %") 	
		end
		local HealthText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if Inked.db.profile.TargetShowHealthNumbers == true then
			HealthText2:SetPoint("CENTER", self, 0,10)
		elseif Inked.db.profile.TargetShowBothNumberandPercent == true then
			HealthText2:SetPoint("LEFT", self, 2,10)
		end
		HealthText2:SetFont(LSM:Fetch("font", Inked.db.profile.TargetHealthfont), Inked.db.profile.TargetHealthFontSize, Inked.db.profile.TargetHealthOutline)
		HealthText2:SetJustifyH("LEFT")	
		if Inked.db.profile.TargetShowHealthNumbers == true  or Inked.db.profile.TargetShowBothNumberandPercent then
			self:Tag(HealthText2, "[Inked:MyHealth]")
		end
		--------------------------
		--  Target Power Values --
		--------------------------		

		local PowerText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		
		if Inked.db.profile.TargetShowPowerPercent == true then
			PowerText:SetPoint("CENTER", self, 0,-24)
		elseif Inked.db.profile.TargetShowBothPowerNumberandPercent == true then
			PowerText:SetPoint("RIGHT", self, -2, -24) 	
		end			
		PowerText:SetFont(LSM:Fetch("font", Inked.db.profile.TargetPowerfont), Inked.db.profile.TargetPowerFontSize, Inked.db.profile.TargetPowerOutline)
		PowerText:SetJustifyH("RIGHT")	
		if Inked.db.profile.TargetShowPowerPercent == true  or Inked.db.profile.TargetShowBothPowerNumberandPercent then
			self:Tag(PowerText, "[perpp]".." %")
		end	
		local PowerText2 = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		if Inked.db.profile.TargetShowPowerNumbers == true then
			PowerText2:SetPoint("CENTER", self, 0,-24)
		elseif Inked.db.profile.TargetShowBothPowerNumberandPercent == true then
			PowerText2:SetPoint("LEFT", self, 2, -24) 
		end								
		PowerText2:SetFont(LSM:Fetch("font", Inked.db.profile.TargetPowerfont), Inked.db.profile.TargetPowerFontSize, Inked.db.profile.TargetPowerOutline)
		PowerText2:SetJustifyH("LEFT")	
		if Inked.db.profile.TargetShowPowerNumbers == true  or Inked.db.profile.TargetShowBothPowerNumberandPercent then
			self:Tag(PowerText2, "[Inked:MyPower]")
		end
		
		----------------------
		--  Target Cast Bar --
		----------------------
		if Inked.db.profile.TargetCastBar == true then
			self.Castbar:SetSize(180, 20)
			self.Castbar:SetPoint('BOTTOMRIGHT', self.Health, 45, -80)
		end

		------------------
		--  Target Aura --
		------------------
		if Inked.db.profile.TargetAuras == true then
			local Auras = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
			Auras:SetPoint("BOTTOMLEFT", self, "TOPLEFT", -5,40)
			Auras:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 40)
			Auras:SetHeight(30 + 6)
			Auras.disableMouse = false

			Auras.size = 30
			Auras.onlyShowTarget = false
			Auras.gap = 2
			Auras.spacing = 2
			Auras.showStealableAuras = true
			Auras.disableCooldown = false
			Auras.num = 32

			Auras.PostCreateIcon = Aura_PostCreateIcon
			self.Auras = Auras
		end

	local PvPIndicator = self:CreateTexture(nil, 'ARTWORK', nil, 1)
    PvPIndicator:SetSize(30, 30)
    PvPIndicator:SetPoint('RIGHT', self, 'LEFT',0,-5)

    local Badge = self:CreateTexture(nil, 'ARTWORK')
    Badge:SetSize(50, 52)
    Badge:SetPoint('CENTER', PvPIndicator, 'CENTER')

    -- Register it with oUF
    PvPIndicator.Badge = Badge
    self.PvPIndicator = PvPIndicator
	--------------------------
	-- Group Role Indicator --
	--------------------------

    local GroupRoleIndicator = self:CreateTexture(nil, 'OVERLAY')
    GroupRoleIndicator:SetSize(24, 24)
    GroupRoleIndicator:SetPoint('RIGHT', self,25,18)
	GroupRoleIndicator:Show()
    self.GroupRoleIndicator = GroupRoleIndicator
	
	 local RaidRoleIndicator = self:CreateTexture(nil, 'OVERLAY')
    RaidRoleIndicator:SetSize(24, 24)
    RaidRoleIndicator:SetPoint('RIGHT', self,25,18)
    -- Register it with oUF
    self.RaidRoleIndicator = RaidRoleIndicator
	
	local SummonIndicator = self:CreateTexture(nil, 'OVERLAY')
    SummonIndicator:SetSize(32, 32)
    SummonIndicator:SetPoint('RIGHT', self,25,-30)

    -- Register it with oUF
    self.SummonIndicator = SummonIndicator

	----------------
	-- Raid icons --
	----------------

	local RaidTargetIndicator = self.Health:CreateTexture(nil, 'OVERLAY')
	RaidTargetIndicator:SetSize(24, 24)
	RaidTargetIndicator:SetPoint('RIGHT', self,25,-6)
	self.RaidTargetIndicator = RaidTargetIndicator
	
	---------------------------------
	--  Target Floating Combat Text--
	---------------------------------
	if Inked.db.profile.TargetFCF == true then
		local fcf = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		fcf:SetSize(24, 24)
		fcf:SetPoint("CENTER",0,150)
		for i = 1, 6 do
			-- give names to these font strings to avoid breaking /fstack and /tinspect
			fcf[i] = fcf:CreateFontString("$parentFCFText" .. i, "OVERLAY")
		end
		
		fcf.font = LSM:Fetch("font", Inked.db.profile.TargetFloatingCombatTextfont)
		fcf.fontHeight = Inked.db.profile.TargetFloatingCombatTextFontSize
		fcf.fontFlags = Inked.db.profile.TargetFloatingCombatTextOutline
		self.FloatingCombatFeedback = fcf
	end
	
	

	end,-- End Target
}
	
	local Shared = function(self, unit)	
	if Inked.db.profile.TargetFrameEnable == false then return end
	self:SetScale(Inked.db.profile.TargetScale)


	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'

	------------------
	--  Health Bars --
	------------------
	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.TargetHealthStatusBar))
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT',-5,0)
	Health:SetPoint('RIGHT')
	Health:SetFrameLevel(2)
	Health:SetFillStyle("REVERSE")
	HealthBackdrop(Health)
	HealthWrap(Health)

	-- Options
	Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	if Inked.db.profile.TargetHealthStatusBarClassClored == true then
		Health.colorClass = true
	end
	Health.colorReaction = true
	Health.colorHealth = true
	self.Health = Health
	self.Health.bg = Healthbg
	
	

    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.TargetPowerStatusBar))
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-30)
	Power:SetPoint('LEFT',0,0)
	Power:SetPoint('RIGHT')
	Power:SetFrameLevel(1)
	Power:SetFillStyle("REVERSE")
	PowerWrap(Power)
	PowerBackdrop(Power)
	Power.frequentUpdates = true
	Power.colorPower = true 
	Power.colorClassNPC = false
	Power.colorClassPet = false 
	self.Power = Power	

	------------------
	--   Portrait --
	------------------
	-- 3D Portrait	
		if Inked.db.profile.TargetPortrait == true then
			local Portrait_Target = CreateFrame('PlayerModel', nil, self, BackdropTemplateMixin and "BackdropTemplate")	
			PortraitWrap(Portrait_Target)
			-- 2D Square
			--local Portrait = self:CreateTexture(nil, 'OVERLAY')
			--Portrait:SetTexCoord(0.15,0.88,0.15,0.85)	
			--self.Portrait = Portrait
			

			self.Portrait_Target = Portrait_Target	
		end


	--------------
	-- Cast Bar --
	--------------
	if Inked.db.profile.TargetCastBar == true then
		local Castbar = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
		Castbar:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.TargetCastBarStatusBar))
		Castbar:SetStatusBarColor(InkedCastBarColors.r,InkedCastBarColors.g,InkedCastBarColors.b,1)
		-- Add a background
		CastBarBackdrop(Castbar)
		CastBarWrap(Castbar)
		Castbar:SetFillStyle("REVERSE")
		-- Add a spark
		local Spark = Castbar:CreateTexture(nil, "OVERLAY")
		Spark:SetSize(40, 35)
		Spark:SetBlendMode("ADD")
		Spark:SetPoint('CENTER', Castbar:GetStatusBarTexture(), 'RIGHT', 0, 0)
		-- Add a timer
		local Time = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Time:SetFont(LSM:Fetch("font", Inked.db.profile.TargetCastBarfont), Inked.db.profile.TargetCastBarFontSize, Inked.db.profile.TargetCastBarOutline)
		Time:SetTextColor(0.95, 0.95, 0.95)
		Time:SetPoint("RIGHT", Castbar, -3, 0)
		-- Add spell text
		local Text = Castbar:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
		Text:SetFont(LSM:Fetch("font", Inked.db.profile.TargetCastBarfont), Inked.db.profile.TargetCastBarFontSize, Inked.db.profile.TargetCastBarOutline)
		Text:SetTextColor(0.95, 0.95, 0.95)
		Text:SetPoint("LEFT", Castbar, 3, 0)
		-- Add Shield
		local Shield = Castbar:CreateTexture(nil, "OVERLAY")
		Shield:SetSize(22, 15)
		Shield:SetPoint("CENTER", Castbar)
		-- Add Icon
		local Icon = Castbar:CreateTexture(nil, 'OVERLAY')
		Icon:SetSize(22, 22)
		Icon:SetPoint('RIGHT', Castbar, 'RIGHT',24,0)
		-- Add safezone
		local SafeZone = Castbar:CreateTexture(nil, "OVERLAY")
		self.Castbar = Castbar
		self.Castbar.bg = Background
		self.Castbar.Spark = Spark
		self.Castbar.Time = Time
		self.Castbar.Text = Text
		self.Castbar.SafeZone = SafeZone
		self.Castbar.Icon = Icon
	end
	-----------------
	-- Smooth Bars --
	-----------------
	self.Health.Smooth = true
	if self.Power then
		self.Power.Smooth = true
	end
	-----------------
	-- Elites --
	-----------------
	local EliteText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") 
		EliteText:SetWidth(50)
		EliteText:SetPoint("RIGHT", self, 88,0) 
		EliteText:SetFont(LSM:Fetch("font", Inked.db.profile.TargetCastBarfont), 30, "OUTLINE")
		EliteText:SetJustifyH("RIGHT")--classification
		EliteText:SetTextColor(0.73,0.78,0.15,1)

		NameplateEliteIconFrame = self:CreateTexture(nil, "BACKGROUND")
		NameplateEliteIconFrame:SetTexture("")
		NameplateEliteIconFrame:SetPoint("RIGHT", self, 4,0)
		NameplateEliteIconFrame:SetSize(32, 16)
		self:Tag(EliteText, "[shortclassification]") 
	
		
	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("InkedTarget", Shared)
oUF:Factory(function(self)
if Inked.db.profile.TargetFrameEnable == false then return end

		TargetX = Inked.db.profile.TargetX
		TargetY = Inked.db.profile.TargetY
	-----------------
	-- Unit Set Up --
	-----------------
     self:SetActiveStyle("InkedTarget")
	-- self:Spawn("target"):SetPoint("CENTER",UIParent,"CENTER",35,-250)
	  if Inked.db.profile.TargetPoint == nil then
		 self:Spawn("Target"):SetPoint("Center",UIParent,TargetX,TargetY)
		MoverTarget:SetPoint("Center",UIParent,TargetX,TargetY)
	  else
		 self:Spawn("Target"):SetPoint(Inked.db.profile.TargetPoint,UIParent,TargetX,TargetY)
		MoverTarget:SetPoint(Inked.db.profile.TargetPoint,UIParent,TargetX,TargetY)
	  end

end)
